--[[ DISABLE ADDON IF CHAR ISN'T A PALADIN]]--
if select(2, UnitClass('player')) ~= "PALADIN" then
    DisableAddOn("QuiHolyPower")
	return
else
	RegisterStateDriver(PaladinPowerBarFrame, "visibility", "hide")
	DEFAULT_CHAT_FRAME:AddMessage("QuiHolyPower Loaded")
end

--[[ Path to styles directory ]]--
local gfxPath = "Interface\\AddOns\\QuiHolyPower\\gfx\\";

--[[ Add the foldername of style pack in the avalibleStyles table ]]--
local avalibleStyles = { ["basic"] = true, ["basic-2"] = true }
local avalibleStratas = { [1] = "BACKGROUND", [2] = "LOW", [3] = "HIGH", [4] = "DIALOG" } 

--[[ File names of the style pack images ]]--
local hpGfx = { [0]="0.tga", [1]= "1.tga", [2]= "2.tga", [3]= "3.tga", [4]= "4.tga", [5]= "5.tga"}

local locked = true;
local barStyle = nil;
local emptyStyle = nil;
local hpBar, events = CreateFrame("Frame", "QUIHP", UIParent ), {};
local tex = hpBar:CreateTexture( );
local counter = 0;

function events:ADDON_LOADED()
	if( not options ) then 
		DEFAULT_CHAT_FRAME:AddMessage('no saved variables, setting default')
		--[[ Setting up default values ]]--
		hpBar:SetFrameStrata("BACKGROUND")
		hpBar:SetPoint("CENTER", 0, 0 )
		hpBar:SetScale( 1 )
		barStyle = "basic"
		emptyStyle = 0
	else 
		hpBar:SetFrameStrata( options.strata )
		barStyle = options.style
		emptyStyle = options.showEmpty
		hpBar:SetPoint( options.point, options.xOffset, options.yOffset )
		hpBar:SetScale( options.scale )
	end
		
	hpBar:SetWidth(128)
	hpBar:SetHeight(128)
	hpBar:SetAlpha(1)
	hpBar:SetMovable(false)
	tex:SetAllPoints(hpBar)
	tex:SetAlpha(1)

	if( emptyStyle == 1 ) then
		tex:SetTexture( gfxPath..barStyle.."\\0.tga" )
		hpBar:Show()	
	else
		hpBar:Hide()
	end
end

function events:PLAYER_LOGOUT()
	local p, rt, rp, x, y = hpBar:GetPoint(index)
	options = { 
				strata = hpBar:GetFrameStrata(),
				style = barStyle,
				showEmpty = emptyStyle,
				scale = hpBar:GetScale(),
				point = p, 
				xOffset = x,
				yOffset = y,
			}
end
	
function events:UNIT_POWER_UPDATE()
	if( (UnitPower("player", 9 ) == 0  and emptyStyle == 0 ) ) then
		hpBar:Hide()
	else
		hpBar:Show()
	end
	tex:SetTexture( gfxPath..barStyle.."\\"..hpGfx[ UnitPower("player",9 )] )
end


--[[ Show or hide powerbar depending on event states ]]--
function events:PET_BATTLE_OPENING_START( ) hpBar:Hide() end
function events:PET_BATTLE_CLOSE( )hpBar:Show() end	
function events:UNIT_ENTERING_VEHICLE( ) hpBar:Hide() end
function events:UNIT_EXITING_VEHICLE( ) hpBar:Show() end	

hpBar:SetScript("OnEvent",function(self,event,...) events[event](self,...) end)
for k,v in pairs(events) do
    hpBar:RegisterEvent(k)
end


--[[ Command line options ]]--
SLASH_QUIHP1  = "/quihp";

SlashCmdList["QUIHP"] = function( cmd_line )
	local cmd, param = strsplit(" ", cmd_line, 2)
	if( cmd == "lock") then 
		hpBar:toggleLock( options.strata )
	elseif( cmd == "scale" ) then
		if( not param ) then
			DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
			DEFAULT_CHAT_FRAME:AddMessage( " Scale is set to: "..hpBar:GetScale() )
		else
			hpBar:SetScale( param )
			DEFAULT_CHAT_FRAME:AddMessage( "QUI holyPowerBar:") 
			DEFAULT_CHAT_FRAME:AddMessage( " Scale set to: "..param )
		end
	elseif( cmd == "style" ) then
		if(  not param ) then 
			DEFAULT_CHAT_FRAME:AddMessage("QUI HolyPowerBar:" )
			DEFAULT_CHAT_FRAME:AddMessage(" Avalible Styles")
			for k,v in pairs( avalibleStyles ) do
				DEFAULT_CHAT_FRAME:AddMessage( "  "..k )
			end
		elseif(  param  ) then	
			if( avalibleStyles[ param ] ) then
				barStyle = param
				tex:SetTexture( gfxPath..barStyle.."\\"..hpGfx[ UnitPower("player",9 )] )
				DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
				DEFAULT_CHAT_FRAME:AddMessage( " Style set to: "..param )
			else 
				DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
				DEFAULT_CHAT_FRAME:AddMessage( " Style '"..param.."' is not avalible!" )
			end
		end
	-- [[ Toggle emptybar ]]--	
	elseif( cmd == "emptybar" ) then
		if( emptyStyle == 1 ) then
			if( UnitPower("player",9 ) == 0 ) then
				hpBar:Hide()
			end
			emptyStyle = 0
			
			DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:" )
			DEFAULT_CHAT_FRAME:AddMessage( "  Hide empty holypower bar" )
		else
			if( UnitPower("player",9 ) == 0 ) then
				hpBar:Show()
			end
			emptyStyle = 1
			
			DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:" )
			DEFAULT_CHAT_FRAME:AddMessage( "  Show empty holypower bar" )
		end
	--[[ Change Frame strata ]]
	elseif( cmd == "strata" ) then
		if( not param ) then  
		DEFAULT_CHAT_FRAME:AddMessage( #avalibleStratas )
			DEFAULT_CHAT_FRAME:AddMessage("QUI HolyPowerBar:" )
			DEFAULT_CHAT_FRAME:AddMessage(" Frame strata is set to: \""..hpBar:GetFrameStrata().."\"" )
			DEFAULT_CHAT_FRAME:AddMessage(" Avalible options are:")
			for i =1, #avalibleStratas do 
				DEFAULT_CHAT_FRAME:AddMessage("  ["..i.."] = \""..avalibleStratas[i].."\"" )
			end
		else 
			DEFAULT_CHAT_FRAME:AddMessage("QUI HolyPowerBar:\n Frame strata has been set to: " ..avalibleStratas[ tonumber(param) ] )
			hpBar:SetFrameStrata( avalibleStratas[ tonumber(param) ] )
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:" )
		DEFAULT_CHAT_FRAME:AddMessage( " Command line options:" )
		DEFAULT_CHAT_FRAME:AddMessage( "   /quihp lock      (To lock or unlock frame)" )
		DEFAULT_CHAT_FRAME:AddMessage( "   /quihp scale     <number>(To set scale in. Default value is 1.0)" )
		DEFAULT_CHAT_FRAME:AddMessage( "   /quihp style     <string>(To set style. Default style is basic)" )
		DEFAULT_CHAT_FRAME:AddMessage( "   /quihp emptybar  (Toggles empty bar visibility. Default is visible)" )
		DEFAULT_CHAT_FRAME:AddMessage( "   /quihp strata    <number>(To set Frame strata. Leave empty for avalible options)" )
	end
end

function hpBar:toggleLock( strata )
	if locked then
		DEFAULT_CHAT_FRAME:AddMessage( 'QUI HolyPowerBar: Unlocked' )
		locked = false
		
		hpBar:SetMovable(true)
		hpBar:EnableMouse(true)
		hpBar:RegisterForDrag("LeftButton")
		hpBar:SetScript("OnDragStart", hpBar.StartMoving)
		hpBar:SetScript("OnDragStop", hpBar.StopMovingOrSizing)
		
		if( not( hpBar:GetFrameStrata() == "DIALOG" ) ) then
			DEFAULT_CHAT_FRAME:AddMessage('Temporary changing frame strata to "DIALOG"')
			hpBar:SetFrameStrata("DIALOG")
		end
		
		hpBar:Show()
		if( emptyStyle == 0 and UnitPower("player",9) == 0) then 
			tex:SetTexture( gfxPath..barStyle.."\\"..hpGfx[ UnitPower("player",9 )] )
		end
	else  
		DEFAULT_CHAT_FRAME:AddMessage( 'QUI HolyPowerBar locked' )
		
		locked = true
		hpBar:SetMovable(false)
		hpBar:EnableMouse(false)
		hpBar:RegisterForDrag()
		hpBar:SetScript("OnDragStart", nil)
		hpBar:SetScript("OnDragStop", nil)
		
		if( (emptyStyle == 0 and UnitPower("player",9) == 0) ) then
			hpBar:Hide()
		end
		hpBar:SetFrameStrata( strata )	
	end	
end

